#include<unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<sys/stat.h>
#include<string.h>


typedef unsigned char uchar;


long long rdtsc();
asm(
"rdtsc:\n"
	"rdtsc\n"
	"ret"
);

long long count;

/******************************************************************************************/

#define kmalloc malloc
#define kfree free

enum{
	MAX_DEVICE_OPEN=16,
	MAX_REGIST_FS=16,
	MAX_FILE_OPEN=16,
	VDIR_MAX_NAME_SIZE=127,	/* ̥ե륷ƥκ̾ */
};

typedef struct{
	const char *name;
	int (*mount)(int);						/* parameteres : device inode  return : root directory block or error=-1 */
	int (*umount)(int);
	void *(*open)(const char*,void*,int);
	int (*read)(void*,void*,size_t,size_t);
	int (*write)(void*,void*,size_t,size_t);
	int (*ioctr)(void*,int,void*);
	int (*rename)(void*,const char*);
	int (*creat)(const char*,void*,int);
	uint (*opendir)(const char*,int,uint);	/* parameters : path,device inode,parent directory block  return : directory block or error=0 */
	int (*mkdir)(const char*,void*,int);
	int (*close)(void*);
}FS;

typedef struct VDIR{
	ushort ref_count;				/* ȥ */
	ushort din;						/* device inode index */
	uint dir_blk;					/* ե륷ƥΥǥ쥯ȥ֥å */
	struct VDIR *next;				/* ƱΡ */
	struct VDIR *prev;				/* ƱΡ */
	struct VDIR *low_next;			/* ΥΡ */
	struct VDIR *high_prev;			/* ΥΡ */
	char name[VDIR_MAX_NAME_SIZE];
}VDIR;

typedef struct{
	ushort fs_num;			/* ե륷ƥʥС */
	ushort ref_count;		/* ȥ */
}MOUNT_FS;

typedef struct{
	ushort ref_count;	/* ȥ */
	ushort din;			/* device inode number */
	uint block;			/* inode֥å */
	size_t offset;		/* ɤ߽񤭳ϥեå */
}F_DSC;

typedef struct{
	F_DSC *fd[MAX_FILE_OPEN];
	VDIR *current_dir;
}FILE_STRUCT;

static FS *fs_info[MAX_REGIST_FS];
static MOUNT_FS mount_fs[MAX_DEVICE_OPEN];
static char _root[sizeof(VDIR)-VDIR_MAX_NAME_SIZE+sizeof(int)];
static VDIR *root=(VDIR*)_root;

extern inline const char *cmp_path(const char *path1,const char *path2)
{
	while(*path1!='\0')
		if(*path1++!=*path2++)return NULL;

	if(*path2=='\0')return path2;
	if(*path2=='/')return ++path2;

	return NULL;
}

extern inline const char *cpy_path(const char *path,char *str)
{
	while((*str=*path++)!='\0')
		if(*str++=='/')
		{
			*(str-1)='\0';
			return path;
		}

	return path-1;
}

uint opendir(const char *path,int din,uint dir)
{
	return 1;
}

VDIR *search_vdir(const char *path,VDIR *vdir)
{
	const char *c;
	VDIR *p,*q;


	for(p=q=vdir->low_next;p!=NULL;p=q)
	{
		if((c=cmp_path(".",path))!=NULL);		/* '.'ξ硣 */
		else if((c=cmp_path("..",path))!=NULL)	/* '..'ξ硣 */
			q=p->high_prev;
		else
		{
			for(q=p;;)
			{
				if((c=cmp_path(p->name,path))!=NULL)break;
				if((p=p->next)==q)return NULL;
			}
			q=p->low_next;
		}

		if(*(path=c)=='\0')return p;
	}

	return NULL;
}


void del_up_vdir(VDIR *vdir)
{
	VDIR *p,*q;


	for(p=vdir;p!=NULL;)
		/* ȤƤʤĲ̥ǥ쥯ȥ꤬ʤк롣 */
		if((p->ref_count==0)&&(p->low_next==NULL))
		{
			p->next->prev=p->prev;
			p->prev->next=p->next;
			q=p->high_prev;
			if(q->low_next==p)q->low_next=p->next;
			if(q->low_next==p)q->low_next=NULL;
			kfree(p);
			p=q;
		}
		else break;
}		

VDIR *get_vdir(const char *path,VDIR *parent)
{
	char str[VDIR_MAX_NAME_SIZE+1];
	const char *c;
	uint block;
	VDIR *p,*q;


	for(p=parent;*path!='\0';)
	{
		/* '.'ξ硣 */
		if((c=cmp_path(".",path))!=NULL)path=c;
		
		/* '..'ξ硣 */
		else if((c=cmp_path("..",path))!=NULL)
		{
			q=p->high_prev;

			/* ȥǥ쥯ȥ꤬ȤƤʤС롣 */
			if((p->ref_count==0)&&(p->low_next==NULL))
			{
				p->next->prev=p->prev;
				p->prev->next=p->next;
				if(q->low_next==p)q->low_next=NULL;
				kfree(p);
			}

			if(q==NULL)return NULL;
			p=q;
			path=c;
		}
		
		/* ̥ǥ쥯ȥ꤬ʤ硢˥ǥ쥯ȥ롣 */
		else if(p->low_next==NULL)
		{
			/* ǥ쥯ȥκ */
			cpy_path(path,str);
			if((block=fs_info[mount_fs[p->din].fs_num]->opendir(str,p->din,p->dir_blk))==0)
			{
				del_up_vdir(p);
				return NULL;
			}
			if((q=(VDIR*)kmalloc(sizeof(VDIR)-VDIR_MAX_NAME_SIZE+strlen(str)+1))==NULL)
			{
				del_up_vdir(p);
				return NULL;
			}
			p->low_next=q;
			q->ref_count=0;
			q->din=p->din;
			q->dir_blk=block;
			q->next=q;
			q->prev=q;
			q->low_next=NULL;
			q->high_prev=p;
			path=cpy_path(path,q->name);
			p=q;
		}

		else
		{
			for(q=p=p->low_next;;)
			{
				if((c=cmp_path(p->name,path))!=NULL)
				{
					path=c;
					break;
				}
				if((p=p->next)==q)
				{
					/* ǥ쥯ȥκ */
					cpy_path(path,str);
					if((block=fs_info[mount_fs[p->din].fs_num]->opendir(str,q->high_prev->din,q->high_prev->dir_blk))==0)return NULL;
					if((q=(VDIR*)kmalloc(sizeof(VDIR)-VDIR_MAX_NAME_SIZE+strlen(str)+1))==NULL)return NULL;
					q->din=p->high_prev->din;
					q->ref_count=0;
					q->dir_blk=block;
					q->next=p->next;
					q->prev=p;
					p->next=q;
					q->next->prev=q;
					q->low_next=NULL;
					q->high_prev=p->high_prev;
					path=cpy_path(path,q->name);
					p=q;

					break;
				}
			}
		}
	}

	return p;
}


int main(int argc,char *argv[])
{
	FS fs_tmp={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,opendir,NULL,NULL};
	
	memset(_root,0,sizeof(VDIR)-VDIR_MAX_NAME_SIZE+sizeof(int));
	root->ref_count=1;
	mount_fs[0].fs_num=1;
	mount_fs[0].ref_count=1;
	fs_info[1]=&fs_tmp;

	{
		char str[16];
		VDIR *vdir;
		
		for(scanf("%s",str);*str!='q';scanf("%s",str))
		{
			if(*str=='a')
			{
				if((vdir=get_vdir(str+2,root))==NULL)
					{printf("Failed get_vdir()\n");continue;}
				printf(
					"vdir->ref_count=%d\n"
					"vdir->din=%d\n"
					"vdir->dir_blk=%d\n"
					"vdir->next=%x\n"
					"vdir->prev=%x\n"
					"vdir->low_next=%x\n"
					"vdir->high_prev=%x\n"
					"vdir->name=%s\n",
					vdir->ref_count,vdir->din,vdir->dir_blk,vdir->next,vdir->prev,vdir->low_next,vdir->high_prev,vdir->name
				);
			}
			else if(*str=='d')
			{
				if((vdir=get_vdir(str+2,root))==NULL)
					{printf("Failed get_vdir()\n");continue;}
				del_up_vdir(vdir);
			}
			else if(*str=='s')
			{
				if((vdir=search_vdir(str+2,root))==NULL)
					{printf("Failed search_vdir()\n");continue;}
				printf(
					"vdir->ref_count=%d\n"
					"vdir->din=%d\n"
					"vdir->dir_blk=%d\n"
					"vdir->next=%x\n"
					"vdir->prev=%x\n"
					"vdir->low_next=%x\n"
					"vdir->high_prev=%x\n"
					"vdir->name=%s\n",
					vdir->ref_count,vdir->din,vdir->dir_blk,vdir->next,vdir->prev,vdir->low_next,vdir->high_prev,vdir->name
				);
			}
		}
	}

	exit(0);
}
